void vfo_set_freq(long f1, long f2, long f3)
{
  #ifdef VFO_SI5351
    vfo5351.set_freq(f1,f2,f3);
  #endif
}

void UpdateFreq() 
{
  uint8_t cwtx = trx.TX && trx.CWTX;

#ifdef MODE_SINGLE_IF
  #if defined(SSBDetectorFreq_USB) && defined(SSBDetectorFreq_LSB) && defined (SSBDetectorFreq_FA)
    vfo_set_freq( // инверсия боковой - гетеродин сверху
      #ifdef CWTX_DIRECT_FREQ
        cwtx? 0: 
      #endif
      CLK0_MULT*(trx.Freq + (trx.sideband == LSB ? (SSBDetectorFreq_USB+Settings[ID_USB_SHIFT]) : (SSBDetectorFreq_LSB+Settings[ID_LSB_SHIFT]))),
      cwtx? 0: CLK1_MULT*(SSBDetectorFreq_FA),
   
      #ifdef CWTX_DIRECT_FREQ
        cwtx? trx.Freq+(trx.sideband == LSB ? -Settings[ID_CW_TONE_HZ]: Settings[ID_CW_TONE_HZ]): 0
      #else
        cwtx? (trx.sideband == LSB ? (SSBDetectorFreq_USB+Settings[ID_USB_SHIFT])+Settings[ID_CW_TONE_HZ]: (SSBDetectorFreq_LSB+Settings[ID_LSB_SHIFT])-Settings[ID_CW_TONE_HZ]): 0
      #endif
    );
  #elif defined(SSBDetectorFreq_USB)
    long f = trx.Freq;
    if (trx.sideband == LSB) {
      f+=(SSBDetectorFreq_USB+Settings[ID_USB_SHIFT]);
    } else {
      f = abs((SSBDetectorFreq_USB+Settings[ID_USB_SHIFT])-f);
    }
    vfo_set_freq(
      #ifdef CWTX_DIRECT_FREQ
        cwtx? 0: 
      #endif
      CLK0_MULT*f,   
       cwtx? 0: CLK1_MULT*(SSBDetectorFreq_FA),
      #ifdef CWTX_DIRECT_FREQ
        cwtx? trx.Freq+(trx.sideband == LSB ? -Settings[ID_CW_TONE_HZ]: Settings[ID_CW_TONE_HZ]): 0
      #else
        cwtx? (SSBDetectorFreq_USB): 0
      #endif
    );
  #elif defined(SSBDetectorFreq_LSB)
    long f = trx.Freq;
    if (trx.sideband == USB) {
      f+=(SSBDetectorFreq_LSB+Settings[ID_LSB_SHIFT]);
    } else {
      f = abs((SSBDetectorFreq_LSB+Settings[ID_LSB_SHIFT])-f);
    }
    vfo_set_freq(
      #ifdef CWTX_DIRECT_FREQ
        cwtx? 0: 
      #endif
      CLK0_MULT*f,
      cwtx? 0: CLK1_MULT*(SSBDetectorFreq_FA),
      #ifdef CWTX_DIRECT_FREQ
        cwtx? trx.Freq+(trx.sideband == LSB ? -Settings[ID_CW_TONE_HZ]: Settings[ID_CW_TONE_HZ]): 0
      #else
        cwtx? (SSBDetectorFreq_LSB+Settings[ID_LSB_SHIFT])-Settings[ID_CW_TONE_HZ]: 0
      #endif
    );
  #else
    #error You must define (SSBDetectorFreq_LSB+Settings[ID_LSB_SHIFT]) or/and (SSBDetectorFreq_USB+Settings[ID_USB_SHIFT])
  #endif 
#endif



}
